//------------------------------------------------------------
#ifndef RODOS5_6_H
#define RODOS5_6_H
//------------------------------------------------------------
#include "onewire.h"
//------------------------------------------------------------
enum {PORT1ON, PORT1OFF, PORT2ON, PORT2OFF, PORTSSET};
enum {T1H, T1L, T2H, T2L};
//------------------------------------------------------------
class RODOS56_t : public OneWire_t
{
public:
    RODOS56_t (int VID, int PID) : OneWire_t(VID, PID) { ONEWIRE_COUNT = 0; }
    RODOS56_t (char *path) : OneWire_t(path) { ONEWIRE_COUNT = 0; }
    ~RODOS56_t () {}

private:
    unsigned char CRC8(unsigned char CRC, unsigned char D);
     //  функции ROM
    bool READ_ROM(unsigned long long &ROM64);
    bool MATCH_ROM(unsigned long long ROM);
    bool SKIP_ROM();

    bool SKIP_ROM_CONVERT();
    bool GET_TEMPERATURE(unsigned long long ROM, float &T);

public:
    bool SEARCH_ROM(unsigned long long ROM_NEXT, int PL);
    //  функции команд
    bool READ_TEMPERATURE(void);
    void PORTS(int COMMAND);

    //термостат
    void TERMOSTATE_READ(void);
    bool TERMOSTATE_WRITE(int TS, float Ftemp);
    bool TERMOSTATE_SET(unsigned long long ROM);
	
	bool AUTONOM_DELAY_SET(unsigned char DELAY);
	signed int AUTONOM_DELAY_READ(void);
public:
    int                 ONEWIRE_COUNT;                      //  количество ROM
private:
    unsigned long long  ONEWIRE_ROM[128];                   //  номера ROM
    float               ONEWIRE_TEMP[128];                  //  температура

};
//------------------------------------------------------------
#endif // RODOS5_6_H
//------------------------------------------------------------
