//------------------------------------------------------------
#include "onewire.h"
#include <iostream>
#include <unistd.h>
//------------------------------------------------------------
//#define DEBUG
//------------------------------------------------------------
bool OneWire_t::OW_RESET()
{   //  RESET, ~3ms
    bool RESULT=false;
    USB_BUF_CLEAR();
    USB_BUFO[1]=0x18;    USB_BUFO[2]=0x48;
    unsigned char N=3;
    while (!RESULT &((N--)>0))
        if (USB_SET_FEATURE())
            {
            usb_t::Sleep(5);
            if (USB_GET_FEATURE()) RESULT=(USB_BUFI[1]==0x18)&(USB_BUFI[2]==0x48)&(USB_BUFI[3]==0x00);
                else RESULT=false;
            }
#ifdef DEBUG
    if (!RESULT) std::cout << "Ошибка OW_RESET" << std::endl; ;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool OneWire_t::OW_READ_BIT(unsigned char &B)
{   //  чтение бита, 3ms
    bool RESULT=false;
    USB_BUF_CLEAR();
    USB_BUFO[1]=0x18;    USB_BUFO[2]=0x81;    USB_BUFO[3]=0x01;
    if (USB_SET_FEATURE())
        {
        usb_t::Sleep(1);
        if (USB_GET_FEATURE())
            { RESULT=(USB_BUFI[1]==0x18)&(USB_BUFI[2]==0x81); B=USB_BUFI[3]&0x01; }
        }
#ifdef DEBUG
    if (!RESULT) std::cout << "Ошибка OW_READ_BIT" << std::endl; ;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool OneWire_t::OW_READ_2BIT(unsigned char &B)
{   //  чтение 2-x бит, 3ms
    bool RESULT=false;
    USB_BUF_CLEAR();
    USB_BUFO[1]=0x18;    USB_BUFO[2]=0x82;
    USB_BUFO[3]=0x01;    USB_BUFO[4]=0x01;
    if (USB_SET_FEATURE())
        {
        usb_t::Sleep(2);
        if (USB_GET_FEATURE())
            { RESULT=(USB_BUFI[1]==0x18)&(USB_BUFI[2]==0x82); B=(USB_BUFI[3]&0x01)+((USB_BUFI[4]<<1)&0x02); }
        }
#ifdef DEBUG
    if (!RESULT) std::cout << "Ошибка OW_READ_2BIT" << std::endl; ;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool OneWire_t::OW_READ_BYTE(unsigned char &B)
{   //  чтение байта, 3ms
    bool RESULT=false;
    USB_BUF_CLEAR();
    USB_BUFO[1]=0x18;    USB_BUFO[2]=0x88;    USB_BUFO[3]=0xFF;
    if (USB_SET_FEATURE())
        {
        usb_t::Sleep(5);
        if (USB_GET_FEATURE())
            { RESULT=(USB_BUFI[1]==0x18)&(USB_BUFI[2]==0x88); B=USB_BUFI[3]; }
        }
#ifdef DEBUG
    if (!RESULT) std::cout << "Ошибка OW_READ_BYTE" << std::endl; ;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool OneWire_t::OW_READ_4BYTE(unsigned long &B)
{   //  чтение 4 байта, 4ms
    bool RESULT=false;
    USB_BUF_CLEAR();
    USB_BUFO[1]=0x18;    USB_BUFO[2]=0x84;    USB_BUFO[3]=0xFF;
    USB_BUFO[4]=0xFF;    USB_BUFO[5]=0xFF;    USB_BUFO[6]=0xFF;
    if (USB_SET_FEATURE())
        {
        usb_t::Sleep(30);
        if (USB_GET_FEATURE())
            { RESULT=(USB_BUFI[1]==0x18)&(USB_BUFI[2]==0x84); B=USB_BUFI[3]+(USB_BUFI[4]<<8)+(USB_BUFI[5]<<16)+(USB_BUFI[6]<<24); }
        }
#ifdef DEBUG
    if (!RESULT) std::cout << "Ошибка OW_READ_4BYTE" << std::endl; ;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool OneWire_t::OW_WRITE_BIT(unsigned char B)
{   //  запись бита, 3ms
    bool RESULT=false;
    USB_BUF_CLEAR();
    USB_BUFO[1]=0x18;    USB_BUFO[2]=0x81;    USB_BUFO[3]=B&0x01;
    if (USB_SET_FEATURE())
        {
        usb_t::Sleep(1);
        if (USB_GET_FEATURE())
            RESULT=(USB_BUFI[1]==0x18)&(USB_BUFI[2]==0x81)&((USB_BUFI[3]&0x01)==(B&0x01));
        }
#ifdef DEBUG
    if (!RESULT) std::cout << "Ошибка OW_WRITE_BIT" << std::endl; ;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool OneWire_t::OW_WRITE_BYTE(unsigned char B)
{   //  запись байта, 3ms
    bool RESULT=false;
    USB_BUF_CLEAR();
    USB_BUFO[1]=0x18;    USB_BUFO[2]=0x88;    USB_BUFO[3]=B;
    if (USB_SET_FEATURE())
        {
        usb_t::Sleep(5);
        if (USB_GET_FEATURE())
            RESULT=(USB_BUFI[1]==0x18)&(USB_BUFI[2]==0x88)&(USB_BUFI[3]==B);
        }
#ifdef DEBUG
    if (!RESULT) std::cout << "Ошибка OW_WRITE_BYTE" << std::endl; ;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool OneWire_t::OW_WRITE_4BYTE(unsigned long B)
{   //  запись 4 байта, 4ms
    bool RESULT=false;
    unsigned char D0, D1, D2, D3;
    D0=B&0xFF;
    D1=(B>>8) &0xFF;
    D2=(B>>16)&0xFF;
    D3=(B>>24)&0xFF;
    USB_BUF_CLEAR();
    USB_BUFO[1]=0x18;    USB_BUFO[2]=0x84;    USB_BUFO[3]=B&0xFF;
    USB_BUFO[4]=(B>>8)&0xFF;
    USB_BUFO[5]=(B>>16)&0xFF;
    USB_BUFO[6]=(B>>24)&0xFF;
    if (USB_SET_FEATURE())
        {
        usb_t::Sleep(30);
        if (USB_GET_FEATURE())
            RESULT=(USB_BUFI[1]==0x18)&(USB_BUFI[2]==0x84)&(USB_BUFI[3]==D0)&(USB_BUFI[4]==D1)&(USB_BUFI[5]==D2)&(USB_BUFI[6]==D3);
        }
#ifdef DEBUG
    if (!RESULT) std::cout << "Ошибка OW_WRITE_4BYTE" << std::endl; ;
#endif
    return RESULT;
}
//------------------------------------------------------------
